"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var AmqpSender = /** @class */ (function () {
    function AmqpSender(channel) {
        this.channel = channel;
    }
    AmqpSender.prototype.declareQueue = function (_a) {
        var name = _a.name, rest = __rest(_a, ["name"]);
        return this.channel.addSetup(function (channel) { return channel.assertQueue(name, rest); });
    };
    AmqpSender.prototype.declareTopic = function (_a) {
        var name = _a.name, type = _a.type;
        return this.channel.addSetup(function (channel) { return channel.assertExchange(name, type); });
    };
    AmqpSender.prototype.bind = function (_a) {
        var queue = _a.queue, topic = _a.topic, routingKey = _a.routingKey;
        return this.channel.addSetup(function (channel) {
            return channel.bindQueue(queue, topic, routingKey);
        });
    };
    AmqpSender.prototype.publish = function (topic, routingKey, message) {
        var content = Buffer.from(JSON.stringify(message.data));
        return this.channel.publish(topic, routingKey, content, {
            deliveryMode: 2,
            headers: message.headers
        });
    };
    return AmqpSender;
}());
exports.AmqpSender = AmqpSender;
//# sourceMappingURL=amqp-sender.js.map