"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var event_listener_1 = require("./listeners/event-listener");
var query_listener_1 = require("./listeners/query-listener");
var ReactiveCommons = /** @class */ (function () {
    function ReactiveCommons(broker, registry, config) {
        this.broker = broker;
        this.registry = registry;
        this.config = config;
    }
    ReactiveCommons.prototype.start = function () {
        var connection = this.broker.connect();
        var eventListener = new event_listener_1.EventListener(this.config, connection, this.registry);
        var queryListener = new query_listener_1.QueryListener(this.config, connection, this.registry);
        return Promise.all([
            eventListener.setupResources(),
            queryListener.setupResources(),
            eventListener.startListening(),
            queryListener.startListening()
        ]).then(function () { return connection; });
    };
    return ReactiveCommons;
}());
exports.ReactiveCommons = ReactiveCommons;
//# sourceMappingURL=reactive-commons.js.map