import { AmqpConnectionManager } from 'amqp-connection-manager';
import { Connection } from '../../domain/model/broker.model';
import { AmqpReceiver } from './amqp-receiver';
import { AmqpSender } from './amqp-sender';
import { EventBus } from '../../domain/api/emitters/event-bus';
export declare class AmqpConnection implements Connection {
    private connectionManager;
    id: string;
    private channel;
    private _sender;
    private _receiver;
    private _eventBus;
    readonly sender: AmqpSender;
    readonly receiver: AmqpReceiver;
    readonly eventBus: EventBus;
    constructor(connectionManager: AmqpConnectionManager);
    onConnect(listener: (event: {
        host: string;
    }) => void): void;
    onDisconnect(listener: (err: Error) => void): void;
}
