import { ChannelWrapper } from 'amqp-connection-manager';
import { BrokerSender, Message } from '../../domain/model/broker.model';
import { BindingSpecification, QueueSpecitication, TopicSpecification } from '../../domain/model/resources.model';
export declare class AmqpSender implements BrokerSender {
    private channel;
    constructor(channel: ChannelWrapper);
    declareQueue({ name, ...rest }: QueueSpecitication): Promise<void>;
    declareTopic({ name, type }: TopicSpecification): Promise<void>;
    bind({ queue, topic, routingKey }: BindingSpecification): Promise<void>;
    publish<T>(topic: string, routingKey: string, message: Message<T>): Promise<void>;
}
