import { CommandHandler, HandlerRegistryRoutes, QueryHandler, EventListener } from '../model/message-handlers.model';
export declare class HandlerRegistry {
    private _commandHandlers;
    private _queryHandlers;
    private _eventListeners;
    private eventListenersUpdates;
    readonly commandHandlers: HandlerRegistryRoutes<CommandHandler<any>>;
    readonly queryHandlers: HandlerRegistryRoutes<QueryHandler<any, any>>;
    readonly eventListeners: HandlerRegistryRoutes<EventListener<any>[]>;
    private constructor();
    static register(): HandlerRegistry;
    getCommandHandler<M>(name: string): CommandHandler<M>;
    getQueryHandler<M, R>(resource: string): QueryHandler<M, R>;
    getEventListeners<M>(name: string): EventListener<M>[];
    handleCommand<M>(name: string, handler: CommandHandler<M>): void;
    serveQuery<M, R>(resource: string, handler: QueryHandler<M, R>): void;
    listenEvent<M>(name: string, listener: EventListener<M>): void;
    onEventListenerPushed(handle: (name: string, listener: EventListener<unknown>) => void): void;
    private push;
}
